CREATE OR REPLACE FUNCTION FORNECEDOR_DO_LOTE(
   P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_NRLOTEESTQ   IN LOTE.NRLOTEESTQ%TYPE,
   P_NRSUBLOTE    IN LOTE.NRLOTEESTQ%TYPE,
   P_CDPRODUTO    IN LOTE.CDPRODUTO%TYPE) RETURN VARCHAR IS

   V_CDFORNECED   VARCHAR2(21);
   V_NRINSJURFORN VARCHAR2(20);
   V_NMRAZSOCFORN VARCHAR2(100);
   V_RETURN VARCHAR2(143);
BEGIN
   SELECT MAX(N.CDFORNECED), MAX(F.NRINSJURFORN), MAX(F.NMRAZSOCFORN)
     INTO V_CDFORNECED, V_NRINSJURFORN, V_NMRAZSOCFORN
     FROM LOTE L, ITLANCTOEST I, LANCTOESTOQ A, NOTAFISCAL N, FORNECEDOR F
    WHERE L.CDFILIAL = P_CDFILIAL
      AND L.NRLOTEESTQ = P_NRLOTEESTQ
      AND L.NRSUBLOTE = P_NRSUBLOTE
      AND L.CDPRODUTO = P_CDPRODUTO
      AND L.CDFILIAL = I.CDFILIAL
      AND L.NRLOTEESTQ = I.NRLOTEESTQ
      AND L.NRSUBLOTE = I.NRSUBLOTE
      AND L.CDPRODUTO = I.CDPRODUTO
      AND I.CDFILIAL = A.CDFILIAL
      AND I.NRLANCESTQ = A.NRLANCESTQ
      AND A.IDTPLANCTO IN ('E','2')
      AND A.CDFILIAL = N.CDFILIAL
      AND A.NRLANCTONF = N.NRLANCTONF
      AND N.CDFORNECED = F.CDFORNECED;

   V_RETURN := V_CDFORNECED||''||V_NRINSJURFORN||''||V_NMRAZSOCFORN;
   RETURN(V_RETURN);
END;
/ 
-- VERSAO --
BEGIN ATUVEROBJ('FORNECEDOR_DO_LOTE','6.35.020'); END;
/
