IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_CMP_FILIALROTA' AND
                 TYPE = 'TR' 		        AND
	              U.UID = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_CMP_FILIALROTA
GO

CREATE  TRIGGER LOG_CMP_FILIALROTA
ON FILIALROTA
FOR INSERT, UPDATE, DELETE

AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(80);
   DECLARE  @V_DESC      VARCHAR(1500);
   DECLARE  @V_DTOPER    DATETIME;

   /*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO        VARCHAR(1) ;

   DECLARE @V_NEW_CDROTATRANS      VARCHAR(6);
   DECLARE @V_NEW_CDFILIAL         VARCHAR(4);
   DECLARE @V_NEW_CDFILIROTA       VARCHAR(4);
   DECLARE @V_NEW_NRORDFILROTA     VARCHAR(3);
   DECLARE @V_NEW_IDROTAPRINCFILI  VARCHAR(1);

   DECLARE @V_OLD_CDROTATRANS      VARCHAR(6);
   DECLARE @V_OLD_CDFILIAL         VARCHAR(4);
   DECLARE @V_OLD_CDFILIROTA       VARCHAR(4);
   DECLARE @V_OLD_NRORDFILROTA     VARCHAR(3);
   DECLARE @V_OLD_IDROTAPRINCFILI  VARCHAR(1);

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
         'D' IDCOMANDO,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          DELETED.CDROTATRANS,
          DELETED.CDFILIAL,
          DELETED.CDFILIROTA,
          DELETED.NRORDFILROTA,
          DELETED.IDROTAPRINCFILI
      FROM
         DELETED
       WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
            'U' IDCOMANDO,
             INSERTED.CDROTATRANS,
             INSERTED.CDFILIAL,
             INSERTED.CDFILIROTA,
             INSERTED.NRORDFILROTA,
             INSERTED.IDROTAPRINCFILI,
             DELETED.CDROTATRANS,
             DELETED.CDFILIAL,
             DELETED.CDFILIROTA,
             DELETED.NRORDFILROTA,
             DELETED.IDROTAPRINCFILI

        FROM
             INSERTED,
             DELETED
       WHERE
             INSERTED.CDROTATRANS     =  DELETED.CDROTATRANS      AND
             INSERTED.CDFILIAL        =  DELETED.CDFILIAL         AND
             INSERTED.CDFILIROTA      =  DELETED.CDFILIROTA       AND
             INSERTED.NRORDFILROTA    =  DELETED.NRORDFILROTA     AND
             INSERTED.IDROTAPRINCFILI =  DELETED.IDROTAPRINCFILI

      UNION ALL

      SELECT
             'I' IDCOMANDO,
             INSERTED.CDROTATRANS,
             INSERTED.CDFILIAL,
             INSERTED.CDFILIROTA,
             INSERTED.NRORDFILROTA,
             INSERTED.IDROTAPRINCFILI,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_CDROTATRANS,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDFILIROTA,
                                 @V_NEW_NRORDFILROTA,
                                 @V_NEW_IDROTAPRINCFILI,
                                 @V_OLD_CDROTATRANS,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_CDFILIROTA,
                                 @V_OLD_NRORDFILROTA,
                                 @V_OLD_IDROTAPRINCFILI;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO= 'D' /*DELETING*/ BEGIN
         IF @V_OLD_CDROTATRANS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cd. Rota:'  + @V_OLD_CDROTATRANS + ' ';
         END;
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial:'  + @V_OLD_CDFILIAL + ' ';
         END;
         IF @V_OLD_CDFILIROTA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial Rota:'  + @V_OLD_CDFILIROTA + ' ';
         END;
         IF @V_OLD_NRORDFILROTA IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'N. Ordem:'  + @V_OLD_NRORDFILROTA + ' ';
         END;
         IF @V_OLD_IDROTAPRINCFILI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Rota Princ.:'  + @V_OLD_IDROTAPRINCFILI + ' ';
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDROTATRANS + @V_OLD_CDFILIAL + @V_OLD_CDFILIROTA;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (ISNULL(@V_OLD_CDROTATRANS,'')      <>    ISNULL(@V_NEW_CDROTATRANS,''))     OR
               (ISNULL(@V_OLD_CDFILIAL,'')         <>    ISNULL(@V_NEW_CDFILIAL,''))        OR
               (ISNULL(@V_OLD_CDFILIROTA,'')       <>    ISNULL(@V_NEW_CDFILIROTA,''))      OR
               (ISNULL(@V_OLD_NRORDFILROTA ,'')    <>    ISNULL(@V_NEW_NRORDFILROTA ,''))   OR
               (ISNULL(@V_OLD_IDROTAPRINCFILI,'')  <>    ISNULL(@V_NEW_IDROTAPRINCFILI,'')) BEGIN

               IF ISNULL(@V_OLD_CDROTATRANS, '') <> ISNULL(@V_NEW_CDROTATRANS, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Cd. Rota:'  + @V_NEW_CDROTATRANS + ' ';
               END;
               IF ISNULL(@V_OLD_CDFILIAL, '') <> ISNULL(@V_NEW_CDFILIAL, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Filial:'  + @V_NEW_CDFILIAL + ' ';
               END;
               IF ISNULL(@V_OLD_CDFILIROTA , '') <> ISNULL(@V_NEW_CDFILIROTA , '') BEGIN
                  SET @V_DESC = @V_DESC + 'Filial Rota:' + @V_NEW_CDFILIROTA + ' ';
               END;
               IF ISNULL(@V_OLD_NRORDFILROTA , '') <> ISNULL(@V_NEW_NRORDFILROTA , '') BEGIN
                  SET @V_DESC = @V_DESC + 'N. Ordem:' + @V_NEW_NRORDFILROTA  + ' ';
               END;
               IF ISNULL(@V_OLD_IDROTAPRINCFILI, '') <> ISNULL(@V_NEW_IDROTAPRINCFILI, '') BEGIN
                  SET @V_DESC = @V_DESC + 'Rota Princ.:' + @V_NEW_IDROTAPRINCFILI + ' ';
               END;

               SET  @V_TIPO   = '2';
               SET  @V_ITPESQ = @V_NEW_CDROTATRANS + @V_NEW_CDFILIAL + @V_NEW_CDFILIROTA + @V_NEW_NRORDFILROTA  + @V_NEW_IDROTAPRINCFILI;
            END;
         END
         ELSE BEGIN
            IF @V_NEW_CDROTATRANS IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Cd. Rota:' + @V_NEW_CDROTATRANS + ' ';
            END;
            IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial:' + @V_NEW_CDFILIAL + ' ';
            END;
            IF @V_NEW_CDFILIROTA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial Rota:' + @V_NEW_CDFILIROTA + ' ';
            END;
            IF @V_NEW_NRORDFILROTA IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'N. Ordem:' + @V_NEW_NRORDFILROTA + ' ';
            END;
            IF @V_NEW_IDROTAPRINCFILI IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Rota Princ.:' + @V_NEW_IDROTAPRINCFILI + ' ';
            END;

            SET  @V_TIPO   = '1';
            SET  @V_ITPESQ = @V_NEW_CDROTATRANS + @V_NEW_CDFILIAL + @V_NEW_CDFILIROTA + @V_NEW_NRORDFILROTA  + @V_NEW_IDROTAPRINCFILI;
         END;
      END;
      EXEC NMUSUARIO @V_USUARIO;
      SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
      IF (@V_TIPO <> '0')  BEGIN
         IF @V_DESC IS NOT NULL BEGIN
            IF @V_USUARIO IS NOT NULL BEGIN
               SET  @V_DTOPER = GETDATE();
               SET  @V_DESC = SUBSTRING(@V_DESC, 1, 300);
                  INSERT INTO LOGOPERA
                             (NMTABELA, DTOPERACAO, NMRESPOPER,
                              IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
                         VALUES
                             ('FILIALROTA', @V_DTOPER, @V_USUARIO,
                              @V_TIPO, @V_ITPESQ, @V_DESC, @V_NEW_CDFILIAL);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_CDROTATRANS,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDFILIROTA,
                                 @V_NEW_NRORDFILROTA,
                                 @V_NEW_IDROTAPRINCFILI,
                                 @V_OLD_CDROTATRANS,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_CDFILIROTA,
                                 @V_OLD_NRORDFILROTA,
                                 @V_OLD_IDROTAPRINCFILI;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CMP_FILIALROTA','5.50.xxx';
GO
